# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module constants
##   Dfinit des constantes gnrales utilises un peu partout
## ----------------------------------------------------------------------

# Version du canard
PYCC_VERSION = "0.8.10"
AUTOCONFIG_SERVER = "chrisix.free.fr/pycoincoin/config"

# Bot Status
BOT_STOP = 0
BOT_RUNNING = 1

# Couleurs en fonction du status (pour leds, onglets)
STATE_HTTP    = "#00A000"
STATE_ERROR   = "#FF0000"
STATE_WARNING = "#FF8000"
STATE_STOP    = "#909090"
STATE_NEW     = "#FCFCDA"
STATE_INFO    = "#3333DD"
STATE_OK      = ""
STATE_BLINK   = "#AAAAFF"

# Couleurs diverses
COLOR_TITLE = "#FFE902"
HITXT_BACK = "#DADADA"

# Actions
ACTION_POST = 'post'
ACTION_STYLE = 'style'
ACTION_REMSTYLE = 'remstyle'
ACTION_SYSCMD = 'cmd'
ACTION_PLUGIN = 'plugin'
ACTION_MSG = 'message'
ACTION_TEXT = 'text'
ACTION_TAGGER = 'tagger'
ACTION_RESTAURE = 'restaure'
ACTION_SOUND = 'sound'
ACTION_BLINK = 'blink'
ACTION_REFRESHALL = 'refreshall'

actions_descr = { \
  ACTION_POST:     "Poster",
  ACTION_STYLE:    "Appliquer un style",
  ACTION_REMSTYLE: "Supprime un style",
  ACTION_PLUGIN:   "Lancer un plugin",
  ACTION_RESTAURE: "Restaurer un post  son tat original",
  ACTION_SYSCMD:   "Lancer une commande systme",
  ACTION_MSG:      "Afficher un message",
  ACTION_SOUND:    "Jouer un son",
  ACTION_TEXT:     "Insrer du texte dans le Palmipde",
  ACTION_TAGGER:   "Insrer une balise dans le Palmipde",
  ACTION_BLINK:    "Faire clignoter l'onglet",
  ACTION_REFRESHALL: "Redessiner tout le pinnipde"
}

ACTIONMODE_MULTI = " tous les posts matchant le contexte"
ACTIONMODE_CTXT = "au post slectionn seulement"
ACTIONMODE_ONCE = "une seule fois, peu importe le contexte"

# actions_only_once = [ ACTION_REFRESHALL ]

# Contextes des actions
PALMI  = 0
PINNI  = 1
MENU   = 2
GLOBAL = 3
BOT    = 4

actions_ctx = { \
  PALMI: [ ACTION_POST, ACTION_PLUGIN, ACTION_TEXT, ACTION_TAGGER, ACTION_SOUND ],
  PINNI: [ ACTION_POST, ACTION_STYLE, ACTION_REMSTYLE, ACTION_PLUGIN, ACTION_RESTAURE, ACTION_SYSCMD, ACTION_MSG, ACTION_SOUND, ACTION_TEXT, ACTION_REFRESHALL ],
  MENU:  [ ACTION_POST, ACTION_STYLE, ACTION_REMSTYLE, ACTION_PLUGIN, ACTION_RESTAURE, ACTION_SYSCMD, ACTION_MSG, ACTION_SOUND, ACTION_TEXT, ACTION_REFRESHALL ],
  BOT:   [ ACTION_POST, ACTION_STYLE, ACTION_PLUGIN, ACTION_RESTAURE, ACTION_SYSCMD, ACTION_MSG, ACTION_SOUND, ACTION_BLINK ]
}

# Conditions
COND_ANY  = 0
COND_ALL  = 1

# Oprateurs de conditions
OP_MATCHES = 'match'
OP_NOT_MATCHES = 'nomatch'
OP_HAS_REF_TO = 'hasref'
OP_CURRENT_ID = 'curid'
OP_ONE_ID = 'oneid'
OP_GREATER = 'sup'
OP_LESS = 'less'

op_descr = {
  OP_MATCHES:     "matche",
  OP_NOT_MATCHES: "ne matche pas",
  OP_HAS_REF_TO:  "contient une horloge vers",
  OP_CURRENT_ID:  "est mon identit par dfaut",
  OP_ONE_ID:      "est une de mes identits",
  OP_GREATER:     "est plus grand que",
  OP_LESS:        "est plus petit que"
}


# Ensembles de touches, pour les hotkeys
ignorekeys = [ "Caps_Lock", "Num_Lock", "Win", "Home", "End", "Insert", "Multi_Key" ]
modifkeys  = [ "App", "Control", "Alt", "Shift" ]
erasekeys  = [ "BackSpace", "Delete" ]

# Escapage pour les regexps
regexp_escape = "^$()[]{}+*?\\"

# Boutons pour les CoinDialogs
BUT_OK     = 'OK'
BUT_CANCEL = 'Annuler'
BUT_SAVE   = 'Sauvegarder'
BUT_APPLY  = 'Appliquer'
BUT_CLOSE  = 'Fermer'
BUT_NEW    = 'Nouveau...'
BUT_DEL    = 'Supprimer'

# Champs des posts
POST_FIELDS = { \
  'id':      "Identifiant du post",
  'time':    "Heure du post",
  'date':    "Date du post",
  'info':    "User agent du posteur",
  'login':   "Login du posteur",
  'message': "Message",
  'troll':   "Score trollomtre"
}
available_attrs = ['id', 'date', 'time', 'login', 'info', 'message']

# Types de champs
TYPE_STR  = 'str'
TYPE_INT  = 'int'
TYPE_BOOL = 'bool'
TYPE_LIST = 'list'
TYPE_FILE = 'file'
TYPE_DIR  = 'dir'
TYPE_COLOR  = 'color'
TYPE_CHOICE = 'choice'
TYPE_CHOICE_SINGLE = 'choice_single'
TYPE_CHOICE_MULTI  = 'choice_multi'

# Actions asynchrones dans le pinnipde ncessitant l'appel au MutexWriter
PINNI_ADD = 'add'
PINNI_REPLACE = 'replace'
PINNI_INSERT = 'insert'
PINNI_DELETE = 'delete'
PINNI_SETSTYLE = 'setstyle'
PINNI_IMAGE = 'image'
