# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module cowboyz
##   Ce module dfinit le plug-in c0wb0yz
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *

morse_map = { \
  'A': '.-',   'N': '-.',   '0': '-----',
  'B': '-...', 'O': '---',  '1': '.----',
  'C': '-.-.', 'P': '.--.', '2': '..---',
  'D': '-..',  'Q': '--.-', '3': '...--',
  'E': '.',    'R': '.-.',  '4': '....-',
  'F': '..-.', 'S': '...',  '5': '.....',
  'G': '--.',  'T': '-',    '6': '-....',
  'H': '....', 'U': '..-',  '7': '--...',
  'I': '..',   'V': '...-', '8': '---..',
  'J': '.---', 'W': '.--',  '9': '----.',
  'K': '-.-',  'X': '-..-', '@': '.--.-.',
  'L': '.-..', 'Y': '-.--',
  'M': '--',   'Z': '--..',
  u'': '.-.-',    '.': '.-.-.-',
  u'': '.--.-',   ',': '--..--',
  u'': '.--.-',   ':': '---...',
                  '?': '..--..',
  u'': '..-..',   "'": '.----.',
  u'': '--.--',   '-': '-....-',
  u'': '---.',    '/': '-..-.',
  u'': '..--',    '(': '-.--.-',
                  '"': '.-..-.'
}

pam_esrom = {}
for (key, val) in morse_map.items():
  pam_esrom[val] = key

def build_plugins(pycc):
  return { \
    'morseencode': MorseEncode(pycc, "Morse Encoder", "Code le texte en morse"),
    'morsedecode': MorseDecode(pycc, "Morse Decoder", "Dcode un texte en morse en texte ... lisible")
  }

class MorseEncode(TextPlugin):
  
  def get_style(self):
    return None
  
  def text_transform(self, text, tags={}):
    res = ''
    for ch in text:
      uch = ch.upper()
      if uch in "   \n":
        if res[-2] == "/": continue
        res += "/ "
      elif uch in morse_map.keys():
        res += morse_map[uch]+" "
      else:
        res += ch+" "
    if res[-2] == "/": res = res[:-2]
    return res
  
class MorseDecode(TextPlugin):
  
  def get_style(self):
    return None
  
  def text_transform(self, text, tags={}):
    res = ''
    for word in text.split("/"):
      for letter in word.split(" "):
        if letter in pam_esrom.keys():
          res += pam_esrom[letter].lower()
        else:
          res += letter
      res += " "
    return res
