# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module cowboyz
##   Ce module dfinit le plug-in c0wb0yz
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *

semaphore_map = { \
  u'A': u'/o!',  u'N': u'/o\\', 
  u'B': u'_o!',  u'O': u'_\\o', 
  u'C': u'\\o!', u'P': u'_o', 
  u'D': u'o!',  u'Q': u'_o/', 
  u'E': u'!o/',  u'R': u'_o_', 
  u'F': u'!o_',  u'S': u'_o\\', 
  u'G': u'!o\\', u'T': u'\\o', 
  u'H': u'_/o',  u'U': u'\\o/', 
  u'I': u'/o',  u'V': u'o\\', 
  u'J': u'o_',  u'W': u'o/_', 
  u'K': u'/o',  u'X': u'o<',
  u'L': u'/o/',  u'Y': u'\\o_',
  u'M': u'/o_',  u'Z': u'o\\_'
}

pam_erohpames = {}
for (key, val) in semaphore_map.items():
  pam_erohpames[val] = key

def build_plugins(pycc):
  return { \
    'semaphoreencode': SemaphoreEncode(pycc, "Semaphore Encoder", "Code le texte en smaphore"),
    'semaphoredecode': SemaphoreDecode(pycc, "Semaphore Decoder", "Dcode un texte en smaphore en texte ... lisible")
  }

class SemaphoreEncode(TextPlugin):
  
  def get_style(self):
    return None
  
  def text_transform(self, text, tags={}):
    res = ur''
    for ch in text:
      uch = ch.upper()
      if uch in ur"   \n":
        if res[-2] == ur":": continue
        res += ur": "
      elif uch in semaphore_map.keys():
        res += semaphore_map[uch]+ur" "
      else:
        res += ch+ur" "
    if res[-2] == ur":":
      res = res[:-2]
    return res
  
class SemaphoreDecode(TextPlugin):
  
  def get_style(self):
    return None
  
  def text_transform(self, text, tags={}):
    res = ur''
    for word in text.split(ur":"):
      for letter in word.split(ur" "):
        if letter in pam_erohpames.keys():
          res += pam_erohpames[letter].lower()
        else:
          res += letter
      res += ur" "
    return res
